<?php
/*
Plugin Name: bp_crypt_mail
Description: E-Mail vor Spams schützen: Umschliessen Sie Ihre E-Mail Adresse in Ihrem WordPress Editor mit [bp_email] [/bp_email] Beispiel: [bp_email] IhrName@test.de [/bp_email] Ersetzen Sie 'IhrName@test.de' mit Ihrer E-Mail Adresse.
Author: Bodo Piotrowski www.webdesign-memmingen.com
copyright: Bodo Piotrowski

E-Mail Adresse vor Spam Robots schützen. 
Kostenlos zum Downloaden. 
Verwendung und kostenlose Weitergabe erlaubt. 
Änderungen nicht erlaubt.

{bp_crypt_mail} copyright: Bodo Piotrowski

{bp_crypt_mail} Der Download und die Verwendung der Software erfolgen
ausschließlich auf eigene Gefahr 
unter Ausschluss jeglicher Haftung/Gewährleistung.


*/


defined('ABSPATH') || exit;


function encode($str, $praef) {
	$str = mb_convert_encoding($str , 'UTF-32', 'UTF-8'); // big endian
	$split = str_split($str, 4);


	$res = "";
	foreach ($split as $c) {
		$cur = 0;
		for ($i = 0; $i < 4; $i++) {
			$cur |= ord($c[$i]) << (8*(3 - $i));
		}
		$res .= $praef . $cur . ";";
	}
	return $res;
}

function encode_hex($str, $praef) {
	$str = mb_convert_encoding($str , 'UTF-32', 'UTF-8'); //big endian
	$split = str_split($str, 4);

	$res = "";
	foreach ($split as $c) {
		$cur = 0;
		for ($i = 0; $i < 4; $i++) {
			$cur |= ord($c[$i]) << (8*(3 - $i));
		}

		if ($praef == '&#x' || $praef == '%')   // in Hex nur umwandeln wenn entsprechendes Präfix
		{
			$cur = dechex($cur);
		}

		if ($praef != '%')                      // Semikolon nur anhängen wenn Präfix kein Prozent
		{
			$res .= $praef . $cur . ';';
		}
		else
		{
			$res .= $praef . $cur;
		}
	}
	return $res;
}

function nach_at($max, $country, $praef)
{
    $res2 = "";
	for ($i = 0; $i < $max; $i++ )
	{
		$res2 = $res2 . encode_hex($country[$i], $praef) . '.';
    }
	return $res2;
}


function bp_crypt_mail_in_content_now($email)
{
	$str_arr    = explode("@", $email);// aufteilen vor und nach @
	$before_at  = encode_hex($str_arr[0], '%');// vor dem @ Zeichen
	$before_at2 = encode_hex($str_arr[0], '&#');// vor dem @ Zeichen
	$before_at3 = encode_hex($str_arr[0], '&#x');// vor dem @ Zeichen
	$country    = explode(".", $str_arr[1]);// nach dem @ Zeichen
	$max        = max(array_keys($country));// eventuell mehr als einen Punkt im domain Namen
	$nach_at    = nach_at($max, $country, '&#x');// encode zusammensetzen mit Punkt am Ende
	$nach_at2   = nach_at($max, $country, '&#');// encode zusammensetzen mit Punkt am Ende
	$land       = encode_hex($country[$max], '&#x');// encode Länderkennung
	$land2      = encode($country[$max], '&#');// encode Länderkennung
	$bp_mail_js = <<<EOF
<script language='JavaScript' type='text/javascript'>
var praef = 'm&#97;' + '&#105;l'  + '&#116;o';
var zusatz = 'hr' + 'ef' + '=';
var eins = '
EOF;
	$bp_mail_js .= $before_at;
	$bp_mail_js .= <<<EOF
';
var eins2 = '
EOF;
	$bp_mail_js .= $before_at2;
	$bp_mail_js .= <<<EOF
';
var at = '%40';
var at2 = '&#x40;';
var nach_at = '
EOF;
	$bp_mail_js .= $nach_at;
	$bp_mail_js .= <<<EOF
'; 
var nach_at2 = '
EOF;
	$bp_mail_js .= $nach_at2;
	$bp_mail_js .= <<<EOF
'; 
var ende = '
EOF;
	$bp_mail_js .= $land;
	$bp_mail_js .= <<<EOF
';
var ende2 = '
EOF;
	$bp_mail_js .= $land2;
	$bp_mail_js .= <<<EOF
';
document.write( '<a ' + zusatz + '\'' + praef + ':' + eins + at + nach_at + ende + '\'>' );
document.write( eins2 + at2 + nach_at2 + ende2 ); document.write( '<\/a>' );
</script>
<noscript>
    <span style='display:none; '>-we love to entertain you-</span><span style='display:inline; '>
EOF;
	$bp_mail_js .= $before_at3;
	$bp_mail_js .= <<<EOF
</span><span style='display:none; '>-xya34</span><span style='display:inline; '>[at]</span><span style='display:none; '>-we still love to entertain you-</span><span style='display:inline; '>
EOF;
	$bp_mail_js .= $nach_at2 . $land2;
	$bp_mail_js .= <<<EOF
</span><br>
</noscript>
EOF;
	return $bp_mail_js;
}


function bp_crypt_mail_in_content( $atts , $content = null ) {
	if ( ! is_email( trim($content) ) ) {
		return;
	}

	$bp_mail_js = bp_crypt_mail_in_content_now($content);
	return $bp_mail_js;
}

add_shortcode( 'bp_email', 'bp_crypt_mail_in_content' );



